﻿//
// Modbus RTU/TCP/UDP WPF C# sample program for IR API Library.
// This demo application is a Visual Studi 2019 C# WPF project for IR-210/IR-712A/IR-712-MTCP.
//
// Release Note:
//   [v2.2.0.0], 2022-June-02
//

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using IRAPI_Ns;

namespace IrAPI_CSharpWPFDemo
{
    /// <summary>
    /// Interaction logic for IrApiDemoStartWin.xaml
    /// </summary>
    public partial class IrApiDemoStartWin : Window
    {
        public IrApiDemoStartWin()
        {
            InitializeComponent();
        }


        private void btnIrApiMbRtuDemo_Click(object sender, RoutedEventArgs e)
        {
            IRMBRTUDemoWin0 IrLibMbRtuDemoWin = new IRMBRTUDemoWin0();
            IrLibMbRtuDemoWin.ShowDialog();
        }

        private void btnIrApiMbTcpDemo_Click(object sender, RoutedEventArgs e)
        {
            IRMTCPDemoWin0 IrLibMbTcpDemoWin = new IRMTCPDemoWin0();
            IrLibMbTcpDemoWin.ShowDialog();
        }

        private void btnIrApiMbUdpDemo_Click(object sender, RoutedEventArgs e)
        {
            IRMUDPDemoWin0 IrLibMbUdpDemoWin = new IRMUDPDemoWin0();
            IrLibMbUdpDemoWin.ShowDialog();
        }

        private void IrApiLibDemoMWin_Loaded(object sender, RoutedEventArgs e)
        {

            // Show the vrsion IR API Library
            UInt32 verValue = IR_API_Class.IR_GetAPIVersion();
            String major = ((verValue >> 24) & 0xFF).ToString(),
                   minor = ((verValue >> 16) & 0xFF).ToString(),
                   revision = ((verValue >> 8) & 0xFF).ToString(),
                   buildNo = (verValue & 0xFF).ToString();

            LbLIrApiLibTitle.Content = "IR API Library v" + major + "." + minor + "." + revision + "." + buildNo;
        }
    }
}
