﻿'
' Modbus UDP VB sample for IR API Library.
' This demo application Is a Visual Studi 2019 VB WPF project for IR-712-MTCP.
' 
' Release Note
'   [v2.2.0.0], 2022-June-02
'
'
Imports System.Text
Imports System.Threading

Public Class IRMUDPDemoVBWin0

    Private socketHandle As Integer = 0              ' Socket handle for Modbus TCP protocol.
    Private mbNetID As Byte = 1                      ' Modbus Net ID
    Private serverIP As UInt32 = 0                   ' IP address Of the IR-712-MTCP
    Private moduleCnt As Byte = 0
    Dim IROutputChArr As Byte() = New Byte(2) {&H1, &H2, &H3}  ' 3 Combinations Of 2 IR output channels.
    Dim deviceNameArr(10) As String                            ' Strings array with 11 elements for IR device names.
    Dim cmdNameArr(511) As String                              ' Strings array with 512 elements for IR cmd names.


    Dim irCmdQtyInDevice As Integer() = New Integer(2) {1, 2, 3}
    Private IrDeviceTotalQty As Integer = 3
    Private IrCmdCurrTotalCmd As Integer = 6

    Dim IrCmdSummaryArr(12) As Integer      ' 13 elements

    Dim thDwLDIR        ' Thread for downloading IR cmds To the IR Module And updating IR cmd numbers In the Textbox "txtIRCmdQtyCurr".
    Dim thLDIR          ' Thread for loading IR cmds from the IR Module And updating IR cmd numbers In the Textbox "txtIRCmdQtyCurr".
    Dim ii              ' for loop index

    Private Sub IRMUDPUtilWin0_Loaded(sender As Object, e As RoutedEventArgs)
        Me.Height = 600

        ' Init combobox of the address type
        cboAddrType.Items.Clear()
        cboAddrType.Items.Add("Static")
        cboAddrType.Items.Add("DHCP")
        cboAddrType.SelectedIndex = 0

        cboAddrType_S.Items.Clear()
        cboAddrType_S.Items.Add("Static")
        cboAddrType_S.Items.Add("DHCP")


        ' Init the combobox of the Modbus Net ID
        cboMBNetID1.Items.Clear()
        cboMBNetID.Items.Clear()
        cboMBNetID_S.Items.Clear()
        For i As Integer = 1 To 247
            cboMBNetID1.Items.Add(i.ToString())
            cboMBNetID.Items.Add(i.ToString())
            cboMBNetID_S.Items.Add(i.ToString())
        Next i

        cboMBNetID1.SelectedIndex = 0
        cboMBNetID.SelectedIndex = 0


        ' Init combobox of HW Mode
        cboHwMode_S.Items.Clear()
        cboHwMode_S.Items.Add("OP")
        cboHwMode_S.Items.Add("Init/FW")

        ' Init. Write action combobox.
        cboWriteAction.Items.Add("No Set")
        cboWriteAction.Items.Add("Set & Reboot")
        cboWriteAction.Items.Add("Set & No Reboot")
        cboWriteAction.SelectedIndex = 1

        ' Init. the combobox of IR command number
        cboIRCmdNo.Items.Clear()
        cboIRCmdNo2.Items.Clear()
        For i As Integer = 1 To 512
            cboIRCmdNo.Items.Add(i.ToString())
            cboIRCmdNo2.Items.Add(i.ToString())
        Next i
        cboIRCmdNo.SelectedIndex = 0
        cboIRCmdNo2.SelectedIndex = 0

        ' Init. the combobox of IR output channel
        cboIROutputCh.Items.Clear()
        cboIROutputCh.Items.Add("1")
        cboIROutputCh.Items.Add("2")
        cboIROutputCh.Items.Add("1 + 2")
        cboIROutputCh.SelectedIndex = 0

        cboIROutputCh2.Items.Clear()
        cboIROutputCh2.Items.Add("1")
        cboIROutputCh2.Items.Add("2")
        cboIROutputCh2.Items.Add("1 + 2")
        cboIROutputCh2.SelectedIndex = 0


        ' Init. Device name comboboxe
        deviceNameArr(0) = "TV"                          ' IR device #1
        deviceNameArr(1) = "Audio"                       ' IR device #2
        deviceNameArr(2) = "A/C"                         ' IR device #3

        cboDeviceName.Items.Clear()
        For i As Integer = 0 To (deviceNameArr.Length - 1)
            cboDeviceName.Items.Add((i + 1).ToString() + "_" + deviceNameArr(i))
        Next i
        cboDeviceName.SelectedIndex = 0


        ' Init. IR command name combobox
        cmdNameArr(0) = "Power Toggle"          ' IR cmd #1
        cmdNameArr(1) = "Vol+"                  ' IR cmd #2
        cmdNameArr(2) = "Vol-"                  ' IR cmd #3
        cmdNameArr(3) = "Power Toggle"          ' IR cmd #4
        cmdNameArr(4) = "Temperature+"          ' IR cmd #5
        cmdNameArr(5) = "Wind Direction"        ' IR cmd #6

        cboIrCmdNameArr.Items.Clear()
        For i As Integer = 0 To (cmdNameArr.Length - 1)
            cboIrCmdNameArr.Items.Add((i + 1).ToString() + "_" + cmdNameArr(i))
        Next i
        cboIrCmdNameArr.SelectedIndex = 0


        ' Init. the IR command summary data in the IR Cmd Data buffer in the IR API library.
        Dim rtn As Integer = 0
        Dim moduleIndex As UShort = &H21          ' Module index. 0x21: IR-712-MTCP
        Dim dataArr(12) As UShort                 ' Array(13 elements) for IR command summary.
        IrCmdSummaryArr(0) = 3                     ' IR device quantity (#1, #2, #3)
        dataArr(0) = 3
        IrCmdSummaryArr(1) = 6                     ' Total IR command quantity
        dataArr(1) = 6
        IrCmdSummaryArr(2) = 1                     ' IR command quantity For IR device #1
        dataArr(2) = 1
        IrCmdSummaryArr(3) = 2                     ' IR command quantity For IR device #2
        dataArr(3) = 2
        IrCmdSummaryArr(4) = 3                     ' IR command quantity For IR device #3
        dataArr(4) = 3

        rtn = IR_API_Class.IR_SetIRCmdSummaryBuffer(moduleIndex, dataArr, dataArr.Length)  ' Set IR cmd summary to buffer.



        ' Init. the IR device name & command name data in the IR Cmd Data buffer in the IR API library.
        Dim IrDevNameArr(99) As Byte    ' 100 elements
        Dim IrCmdNameArr(99) As Byte    ' 100 elements

        For i As Integer = 0 To (dataArr(0) - 1)

            Select Case i

                Case 0  ' for IR device #1
                    For j As Integer = 0 To (dataArr(2) - 1)

                        Dim IrDevNameArrTemp() As Byte = Encoding.UTF8.GetBytes(deviceNameArr(i))
                        Dim IrCmdNameArrTemp() As Byte = Encoding.UTF8.GetBytes(cmdNameArr(j))
                        rtn = IR_API_Class.IR_SetIrDevCmdNameInBuffer(
                                    CUShort(j + 1),
                                    IrDevNameArrTemp, CUShort(IrDevNameArrTemp.Length),
                                    IrCmdNameArrTemp, CUShort(IrCmdNameArrTemp.Length)
                                )
                    Next j

                Case 1    ' for IR device #2
                    For j As Integer = 0 To (dataArr(3) - 1)

                        Dim IrDevNameArrTemp() As Byte = Encoding.UTF8.GetBytes(deviceNameArr(i))
                        Dim IrCmdNameArrTemp() = Encoding.UTF8.GetBytes(cmdNameArr(j + dataArr(2)))
                        rtn = IR_API_Class.IR_SetIrDevCmdNameInBuffer(
                                    CUShort(j + dataArr(2) + 1),
                                    IrDevNameArrTemp, CUShort(IrDevNameArrTemp.Length),
                                    IrCmdNameArrTemp, CUShort(IrCmdNameArrTemp.Length)
                                )
                    Next j

                Case 2    ' for IR device #3
                    For j As Integer = 0 To (dataArr(4) - 1)

                        Dim IrDevNameArrTemp() As Byte = Encoding.UTF8.GetBytes(deviceNameArr(i))
                        Dim IrCmdNameArrTemp() As Byte = Encoding.UTF8.GetBytes(cmdNameArr(j + dataArr(2) + dataArr(3)))
                        rtn = IR_API_Class.IR_SetIrDevCmdNameInBuffer(
                                    CUShort(j + dataArr(2) + dataArr(3) + 1),
                                    IrDevNameArrTemp, CUShort(IrDevNameArrTemp.Length),
                                    IrCmdNameArrTemp, CUShort(IrCmdNameArrTemp.Length)
                                )
                    Next j

                Case Else

            End Select

        Next i

        ' Init. Module Info Index combobox
        cboModuleInfoIndex.Items.Clear()
        For i As Integer = 0 To 9
            cboModuleInfoIndex.Items.Add(i.ToString())
        Next i
        cboModuleInfoIndex.SelectedIndex = 0

        ' Init rectangle
        Rect1.Fill = New SolidColorBrush(System.Windows.Media.Colors.White)

    End Sub

    Private Sub btnGetInterfaces_Click(sender As Object, e As RoutedEventArgs)
        Dim iNICCount As Integer = 0
        IR_API_Class.IR_ChkNIC(iNICCount)
        MessageBox.Show("Number of NICs = " + iNICCount.ToString(), "Check NIC")

        ' Show NIC description
        Dim description(132) As Byte
        Dim actualLen As Integer = 0
        Dim IPAddr As UInt32 = 0
        Dim NB0, NB1, NB2, NB3 As Byte  ' Network address:= NB0.NB1.NB2.NB3
        Dim showStr As String

        For i As Integer = 0 To (iNICCount - 1)

            IR_API_Class.IR_GetNICInfo(i, description, description.Length, actualLen, IPAddr)
            NB0 = CByte((IPAddr >> 24) Mod 256)
            NB1 = CByte((IPAddr >> 16) Mod 256)
            NB2 = CByte((IPAddr >> 8) Mod 256)
            NB3 = CByte(IPAddr Mod 256)
            showStr = String.Format("NIC IPAddr = 0x" + IPAddr.ToString("X") + " := " _
                    + NB0.ToString() + "." + NB1.ToString() + "." + NB2.ToString() + "." + NB3.ToString() _
                    + vbCrLf _
                    + "NIC Description = {0}" _
                    + vbCrLf + vbCrLf _
                    + "Is this IP address of NIC for IR module connection?",
                    Encoding.ASCII.GetString(description, 0, actualLen))

            Dim mResult As MessageBoxResult = MessageBox.Show(showStr, "Check IP Address of Network Adapter", MessageBoxButton.YesNo, MessageBoxImage.Information)
            If (mResult = MessageBoxResult.Yes) Then
                txtIPNICByte0.Text = NB0.ToString()
                txtIPNICByte1.Text = NB1.ToString()
                txtIPNICByte2.Text = NB2.ToString()
                txtIPNICByte3.Text = NB3.ToString()
                Exit For
            End If

        Next i
    End Sub

    Private Sub btnSearchModule_Click(sender As Object, e As RoutedEventArgs)
        moduleCnt = 0
        Dim NicIPAddr As UInt32 = &HC0A80F7CUI          ' ETH NIC = 192.168.15.124
        NicIPAddr = (UInt32.Parse(txtIPNICByte0.Text) << 24) _
                    Or (UInt32.Parse(txtIPNICByte1.Text) << 16) _
                    Or (UInt32.Parse(txtIPNICByte2.Text) << 8) _
                    Or UInt32.Parse(txtIPNICByte3.Text)
        IR_API_Class.IR_EthSearchModules(NicIPAddr, moduleCnt, 500)

        MessageBox.Show("Number of IR modules = " + moduleCnt.ToString())
    End Sub

    Private Sub btnGetModuleInfo_Click(sender As Object, e As RoutedEventArgs)
        If (moduleCnt = 0) Then
            MessageBox.Show("No modules found" _
                                + vbCrLf _
                                + "Click the ""Search IR-712-MTCP"" first.",
                                "Error", MessageBoxButton.OK, MessageBoxImage.Error)
            Return
        End If

        Dim mInfoIndex As UInt16 = UInt16.Parse(cboModuleInfoIndex.Text)
        Dim moduleInfoStruct As IR_API_Class.SearchRespEth = New IR_API_Class.SearchRespEth()

        ' Get the module info by the mInfoIndex which indexes the found IR modules.
        IR_API_Class.IR_EthGetSearchModuleInfo(
                  mInfoIndex,
                  moduleInfoStruct
                )


        ' Module Name
        txtModuleName_S.Text = If((moduleInfoStruct.ucModIndex = &H21), "IR-712-MTCP", "???")

        ' Address Type
        Select Case (moduleInfoStruct.ucAddrType)

            Case 0
                cboAddrType_S.SelectedIndex = 0

            Case 1
                cboAddrType_S.SelectedIndex = 1

            Case Else
                cboAddrType_S.SelectedIndex = -1

        End Select

        ' IP address
        txtIPByte0_S.Text = (CByte((moduleInfoStruct.ulIPAddr >> 24) Mod 256)).ToString()
        txtIPByte1_S.Text = (CByte((moduleInfoStruct.ulIPAddr >> 16) Mod 256)).ToString()
        txtIPByte2_S.Text = (CByte((moduleInfoStruct.ulIPAddr >> 8) Mod 256)).ToString()
        txtIPByte3_S.Text = (CByte(moduleInfoStruct.ulIPAddr Mod 256)).ToString()
        txtIPConnByte0.Text = (CByte((moduleInfoStruct.ulIPAddr >> 24) Mod 256)).ToString()
        txtIPConnByte1.Text = (CByte((moduleInfoStruct.ulIPAddr >> 16) Mod 256)).ToString()
        txtIPConnByte2.Text = (CByte((moduleInfoStruct.ulIPAddr >> 8) Mod 256)).ToString()
        txtIPConnByte3.Text = (CByte(moduleInfoStruct.ulIPAddr Mod 256)).ToString()

        ' Subnet Mask
        txtMaskByte0_S.Text = (CByte((moduleInfoStruct.ulMaskAddr >> 24) Mod 256)).ToString()
        txtMaskByte1_S.Text = (CByte((moduleInfoStruct.ulMaskAddr >> 16) Mod 256)).ToString()
        txtMaskByte2_S.Text = (CByte((moduleInfoStruct.ulMaskAddr >> 8) Mod 256)).ToString()
        txtMaskByte3_S.Text = (CByte(moduleInfoStruct.ulMaskAddr Mod 256)).ToString()

        ' Gateway address
        txtGWByte0_S.Text = (CByte((moduleInfoStruct.ulGWAddr >> 24) Mod 256)).ToString()
        txtGWByte1_S.Text = (CByte((moduleInfoStruct.ulGWAddr >> 16) Mod 256)).ToString()
        txtGWByte2_S.Text = (CByte((moduleInfoStruct.ulGWAddr >> 8) Mod 256)).ToString()
        txtGWByte3_S.Text = (CByte(moduleInfoStruct.ulGWAddr Mod 256)).ToString()

        ' Modbus Net ID
        cboMBNetID_S.SelectedIndex = moduleInfoStruct.ucNetID - 1
        cboMBNetID1.SelectedIndex = moduleInfoStruct.ucNetID - 1

        ' Ethernet idle timeout (ms)
        txtIdleTOut_S.Text = moduleInfoStruct.ulIdleTOut.ToString()

        ' Firmware Version
        txtFwVer_S.Text = (CByte((moduleInfoStruct.ulFwVer >> 16) Mod 256)).ToString() + "." _
                            + (CByte((moduleInfoStruct.ulFwVer >> 8) Mod 256)).ToString() + "." _
                            + (CByte(moduleInfoStruct.ulFwVer Mod 256)).ToString()
        ' HW Mode
        cboHwMode_S.SelectedIndex = If((moduleInfoStruct.ucHwMode = 0), 0, 1)

        ' MAC Address
        txtMACByte0_S.Text = (CByte((moduleInfoStruct.dwlMacAddr >> 40) Mod 256)).ToString("x2")
        txtMACByte1_S.Text = (CByte((moduleInfoStruct.dwlMacAddr >> 32) Mod 256)).ToString("x2")
        txtMACByte2_S.Text = (CByte((moduleInfoStruct.dwlMacAddr >> 24) Mod 256)).ToString("x2")
        txtMACByte3_S.Text = (CByte((moduleInfoStruct.dwlMacAddr >> 16) Mod 256)).ToString("x2")
        txtMACByte4_S.Text = (CByte((moduleInfoStruct.dwlMacAddr >> 8) Mod 256)).ToString("x2")
        txtMACByte5_S.Text = (CByte(moduleInfoStruct.dwlMacAddr Mod 256)).ToString("x2")

    End Sub

    Private Sub btnClearInfoCtrls_Click(sender As Object, e As RoutedEventArgs)
        cboAddrType_S.SelectedIndex = -1
        txtModuleName_S.Text = String.Empty
        txtIPByte0_S.Text = String.Empty
        txtIPByte1_S.Text = String.Empty
        txtIPByte2_S.Text = String.Empty
        txtIPByte3_S.Text = String.Empty
        txtMaskByte0_S.Text = String.Empty
        txtMaskByte1_S.Text = String.Empty
        txtMaskByte2_S.Text = String.Empty
        txtMaskByte3_S.Text = String.Empty
        txtGWByte0_S.Text = String.Empty
        txtGWByte1_S.Text = String.Empty
        txtGWByte2_S.Text = String.Empty
        txtGWByte3_S.Text = String.Empty
        cboMBNetID_S.SelectedIndex = 0
        txtIdleTOut_S.Text = String.Empty
        cboHwMode_S.SelectedIndex = -1
        txtMACByte0_S.Text = String.Empty
        txtMACByte1_S.Text = String.Empty
        txtMACByte2_S.Text = String.Empty
        txtMACByte3_S.Text = String.Empty
        txtMACByte4_S.Text = String.Empty
        txtMACByte5_S.Text = String.Empty
    End Sub

    Private Sub btnChkModuleName_Click(sender As Object, e As RoutedEventArgs)
        Dim moduleIndex As UInt16 = 0

        Dim rtn As Integer = IR_API_Class.IR_MUDP_ChkModuleName(socketHandle, moduleIndex)

        If (moduleIndex = &H21) Then
            txtModuleIndex.Text = "IR-712-MTCP"
        End If
    End Sub

    Private Sub btnUDPNew_Click(sender As Object, e As RoutedEventArgs)
        ' New a socket handle with communicaton by default route table.
        serverIP = (UInt32.Parse(txtIPConnByte0.Text) << 24) _
                    Or (UInt32.Parse(txtIPConnByte1.Text) << 16) _
                    Or (UInt32.Parse(txtIPConnByte2.Text) << 8) _
                    Or (UInt32.Parse(txtIPConnByte3.Text))

        socketHandle = IR_API_Class.IR_MUDP_UDPNew(serverIP, Byte.Parse(cboMBNetID1.Text))
        MessageBox.Show("UDP Socket handle = " + socketHandle.ToString())
    End Sub

    Private Sub btnUDPNew1_Click(sender As Object, e As RoutedEventArgs)
        ' New a socket handle with communicaton by selected network interface (NIC IP).

        Dim NicIPAddr As UInt32 = 0
        NicIPAddr = (UInt32.Parse(txtIPNICByte0.Text) << 24) _
                    Or (UInt32.Parse(txtIPNICByte1.Text) << 16) _
                    Or (UInt32.Parse(txtIPNICByte2.Text) << 8) _
                    Or (UInt32.Parse(txtIPNICByte3.Text))

        serverIP = (UInt32.Parse(txtIPConnByte0.Text) << 24) _
                    Or (UInt32.Parse(txtIPConnByte1.Text) << 16) _
                    Or (UInt32.Parse(txtIPConnByte2.Text) << 8) _
                    Or (UInt32.Parse(txtIPConnByte3.Text))

        socketHandle = IR_API_Class.IR_MUDP_UDPNew1(NicIPAddr, serverIP, Byte.Parse(cboMBNetID1.Text))
        MessageBox.Show("UDP Socket handle = " + socketHandle.ToString())

    End Sub

    Private Sub btnCloseUDPSocket_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = IR_API_Class.IR_MUDP_UDPClose(socketHandle)
        MessageBox.Show("Close UDP Socket handle rtn = " + rtn.ToString())
    End Sub

    Private Sub btnMUDPGetBasicSettings_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = 0
        Dim mtcpBasicSetStruct As IR_API_Class.BasicSetParamsMTCP = New IR_API_Class.BasicSetParamsMTCP()

        mbNetID = Byte.Parse(cboMBNetID1.Text)

        rtn = IR_API_Class.IR_MUDP_GetBasicSetting(
                socketHandle,
                mtcpBasicSetStruct
                )

        If (rtn = IR_API_Class.IR_E_OK) Then

            ' Address Type
            Select Case mtcpBasicSetStruct.ucAddrType

                Case 0
                    cboAddrType.SelectedIndex = 0
                Case 1
                    cboAddrType.SelectedIndex = 1
                Case Else
                    cboAddrType.SelectedIndex = -1

            End Select

            ' IP address
            txtIPByte0.Text = (CByte((mtcpBasicSetStruct.ulIPAddr >> 24) Mod 256)).ToString()
            txtIPByte1.Text = (CByte((mtcpBasicSetStruct.ulIPAddr >> 16) Mod 256)).ToString()
            txtIPByte2.Text = (CByte((mtcpBasicSetStruct.ulIPAddr >> 8) Mod 256)).ToString()
            txtIPByte3.Text = (CByte(mtcpBasicSetStruct.ulIPAddr Mod 256)).ToString()

            ' Subnet Mask
            txtMaskByte0.Text = (CByte((mtcpBasicSetStruct.ulMaskAddr >> 24) Mod 256)).ToString()
            txtMaskByte1.Text = (CByte((mtcpBasicSetStruct.ulMaskAddr >> 16) Mod 256)).ToString()
            txtMaskByte2.Text = (CByte((mtcpBasicSetStruct.ulMaskAddr >> 8) Mod 256)).ToString()
            txtMaskByte3.Text = (CByte(mtcpBasicSetStruct.ulMaskAddr Mod 256)).ToString()

            ' Gateway address
            txtGWByte0.Text = (CByte((mtcpBasicSetStruct.ulGWAddr >> 24) Mod 256)).ToString()
            txtGWByte1.Text = (CByte((mtcpBasicSetStruct.ulGWAddr >> 16) Mod 256)).ToString()
            txtGWByte2.Text = (CByte((mtcpBasicSetStruct.ulGWAddr >> 8) Mod 256)).ToString()
            txtGWByte3.Text = (CByte(mtcpBasicSetStruct.ulGWAddr Mod 256)).ToString()

            ' Modbus Net ID
            cboMBNetID.SelectedIndex = mtcpBasicSetStruct.ucNetID - 1

            ' Ethernet idle timeout (ms)
            txtIdleTOut.Text = mtcpBasicSetStruct.ulIdleTOut.ToString()

            ' Gaptime (ms)
            txtGapTime.Text = mtcpBasicSetStruct.usGapTime.ToString()

            MessageBox.Show("Get Basic Settings OK", "OK")

        Else

            MessageBox.Show("Error in IR_MUDP_GetBasicSetting()", "Fail")

        End If
    End Sub

    Private Sub btnMUDPSetBasicSettings_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = 0
        Dim AddressU32 As UInt32 = 0   ' host byte order

        ' Check Set Option
        If (cboWriteAction.SelectedIndex = -1) Then
            MessageBox.Show("Please select ""Set Options"" combobox first!", "Warning", MessageBoxButton.OK, MessageBoxImage.Warning)
        End If


        Dim mtcpBasicSetStruct As IR_API_Class.BasicSetParamsMTCP = New IR_API_Class.BasicSetParamsMTCP()

        ' Address Type Static(0) Or DHCP(1)
        mtcpBasicSetStruct.ucAddrType = CByte(cboAddrType.SelectedIndex)

        ' IP address
        AddressU32 = UInt32.Parse(txtIPByte3.Text) _
                     Or (UInt32.Parse(txtIPByte2.Text) << 8) _
                     Or (UInt32.Parse(txtIPByte1.Text) << 16) _
                     Or (UInt32.Parse(txtIPByte0.Text) << 24)

        mtcpBasicSetStruct.ulIPAddr = AddressU32

        ' Subnet Mask
        AddressU32 = UInt32.Parse(txtMaskByte3.Text) _
                     Or (UInt32.Parse(txtMaskByte2.Text) << 8) _
                     Or (UInt32.Parse(txtMaskByte1.Text) << 16) _
                     Or (UInt32.Parse(txtMaskByte0.Text) << 24)
        mtcpBasicSetStruct.ulMaskAddr = AddressU32

        ' Gateway Mask
        AddressU32 = UInt32.Parse(txtGWByte3.Text) _
                     Or (UInt32.Parse(txtGWByte2.Text) << 8) _
                     Or (UInt32.Parse(txtGWByte1.Text) << 16) _
                     Or (UInt32.Parse(txtGWByte0.Text) << 24)
        mtcpBasicSetStruct.ulGWAddr = AddressU32


        ' Modbus Net ID
        mtcpBasicSetStruct.ucNetID = CByte(cboMBNetID.SelectedIndex + 1)

        ' Eth Idle Timeout
        mtcpBasicSetStruct.ulIdleTOut = UInt32.Parse(txtIdleTOut.Text)

        ' Gaptime
        mtcpBasicSetStruct.usGapTime = UInt16.Parse(txtGapTime.Text)

        rtn = IR_API_Class.IR_MUDP_SetBasicSetting(socketHandle, mtcpBasicSetStruct, CByte(cboWriteAction.SelectedIndex))

        If (rtn <> IR_API_Class.IR_E_OK) Then
            MessageBox.Show("Set error", "Error")
        Else
            MessageBox.Show("Set OK", "OK")
            Select Case (cboWriteAction.SelectedIndex)
                Case 1 ' Set And reboot
                    txtIPConnByte0.Text = txtIPByte0.Text
                    txtIPConnByte1.Text = txtIPByte1.Text
                    txtIPConnByte2.Text = txtIPByte2.Text
                    txtIPConnByte3.Text = txtIPByte3.Text
                    cboMBNetID1.SelectedIndex = cboMBNetID.SelectedIndex
            End Select
        End If
    End Sub

    Private Sub btnClearSetting_Click(sender As Object, e As RoutedEventArgs)
        cboAddrType.SelectedIndex = 0
        txtIPByte0.Text = String.Empty
        txtIPByte1.Text = String.Empty
        txtIPByte2.Text = String.Empty
        txtIPByte3.Text = String.Empty
        txtMaskByte0.Text = String.Empty
        txtMaskByte1.Text = String.Empty
        txtMaskByte2.Text = String.Empty
        txtMaskByte3.Text = String.Empty
        txtGWByte0.Text = String.Empty
        txtGWByte1.Text = String.Empty
        txtGWByte2.Text = String.Empty
        txtGWByte3.Text = String.Empty
        cboMBNetID.SelectedIndex = 0
        txtIdleTOut.Text = String.Empty
        txtGapTime.Text = String.Empty
    End Sub

    Private Sub btnReboot_Click(sender As Object, e As RoutedEventArgs)
        ' Reboot the IR module.
        Dim rtn As Integer = IR_API_Class.IR_MUDP_RebootIRModule(socketHandle)
        MessageBox.Show("Reboot Module return = " + rtn.ToString())
    End Sub

    Private Sub txtBasicSettingDefault_Click(sender As Object, e As RoutedEventArgs)
        cboAddrType.SelectedIndex = 0
        txtIPByte0.Text = "192"
        txtIPByte1.Text = "168"
        txtIPByte2.Text = "255"
        txtIPByte3.Text = "1"
        txtMaskByte0.Text = "255"
        txtMaskByte1.Text = "255"
        txtMaskByte2.Text = "0"
        txtMaskByte3.Text = "0"
        txtGWByte0.Text = "192"
        txtGWByte1.Text = "168"
        txtGWByte2.Text = "0"
        txtGWByte3.Text = "254"
        cboMBNetID.SelectedIndex = 0
        txtIdleTOut.Text = "0"
        txtGapTime.Text = "80"
    End Sub

    Private Sub btnGetIRCmdSummaryBuff_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = 0
        Dim moduleIndex As UShort = &H21    ' 0x21: IR-712-MTCP
        Dim dataArr(12) As UShort           ' 13 elements
        Dim dataStr As String = String.Empty

        rtn = IR_API_Class.IR_GetIRCmdSummaryBuffer(moduleIndex, dataArr, CUShort(dataArr.Length))

        ' Show the IR command summary.
        For i As Integer = 0 To (dataArr.Length - 1)
            If (i = (dataArr.Length - 1)) Then
                dataStr += (dataArr(i).ToString())
                'dataStr += (dataArr[i].ToString("X4"))
            Else
                dataStr += (dataArr(i).ToString() + "-")
                'dataStr += (dataArr[i].ToString("X4") + "-")
            End If

            IrCmdSummaryArr(i) = dataArr(i)
        Next i

        txtDeviceQty_G.Text = dataArr(0).ToString()
        IrDeviceTotalQty = dataArr(0)
        txtIRCmdQtyTotal_G.Text = dataArr(1).ToString()
        IrCmdCurrTotalCmd = dataArr(1)
        txtIRCmdQtyDevice1_G.Text = dataArr(2).ToString()
        txtIRCmdQtyDevice2_G.Text = dataArr(3).ToString()
        txtIRCmdQtyDevice3_G.Text = dataArr(4).ToString()
        txtIRCmdQtyDevice4_G.Text = dataArr(5).ToString()
        txtIRCmdQtyDevice5_G.Text = dataArr(6).ToString()
        txtIRCmdQtyDevice6_G.Text = dataArr(7).ToString()
        txtIRCmdQtyDevice7_G.Text = dataArr(8).ToString()
        txtIRCmdQtyDevice8_G.Text = dataArr(9).ToString()
        txtIRCmdQtyDevice9_G.Text = dataArr(10).ToString()
        txtIRCmdQtyDevice10_G.Text = dataArr(11).ToString()
        txtIRCmdQtyDevice11_G.Text = dataArr(12).ToString()

        MessageBox.Show(dataStr, "Get dataArr")
    End Sub

    Private Sub btnSetIRCmdSummaryBuff_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = 0
        Dim moduleIndex As UShort = &H21    ' 0x21: IR-712-MTCP
        Dim dataArr(12) As UShort
        Dim dataStr As String = String.Empty

        dataArr(0) = UInt16.Parse(txtDeviceQty.Text)
        IrDeviceTotalQty = dataArr(0)
        dataArr(1) = UInt16.Parse(txtIRCmdQtyTotal.Text)
        IrCmdCurrTotalCmd = dataArr(1)
        dataArr(2) = UInt16.Parse(txtIRCmdQtyDevice1.Text)
        dataArr(3) = UInt16.Parse(txtIRCmdQtyDevice2.Text)
        dataArr(4) = UInt16.Parse(txtIRCmdQtyDevice3.Text)
        dataArr(5) = UInt16.Parse(txtIRCmdQtyDevice4.Text)
        dataArr(6) = UInt16.Parse(txtIRCmdQtyDevice5.Text)
        dataArr(7) = UInt16.Parse(txtIRCmdQtyDevice6.Text)
        dataArr(8) = UInt16.Parse(txtIRCmdQtyDevice7.Text)
        dataArr(9) = UInt16.Parse(txtIRCmdQtyDevice8.Text)
        dataArr(10) = UInt16.Parse(txtIRCmdQtyDevice9.Text)
        dataArr(11) = UInt16.Parse(txtIRCmdQtyDevice10.Text)
        dataArr(12) = UInt16.Parse(txtIRCmdQtyDevice11.Text)


        rtn = IR_API_Class.IR_SetIRCmdSummaryBuffer(moduleIndex, dataArr, CUShort(dataArr.Length))

        For i As Integer = 0 To (dataArr.Length - 1)
            dataStr += (dataArr(i).ToString("X4") + " ")

            IrCmdSummaryArr(i) = dataArr(i)
        Next i

        MessageBox.Show(dataStr, "Set IR Cmd Summary to the library buffer.")
    End Sub

    Private Sub btnGetIrDevCmdNameInBuffer_Click(sender As Object, e As RoutedEventArgs)
        ' Note: The IR learning data buffer of the API library was initilized 
        '       with 3 IR device names And 6 IR command names by IR_SetIrDevCmdNameInBuffer()  
        '       in the IRMTCPDUtilWin0_Loaded() event handler.

        Dim rtn As Integer = 0
        Dim IrDevNameArr(99) As Byte
        Dim IrCmdNameArr(99) As Byte
        Dim IrDevNameLength As UInt16 = 0
        Dim IrCmdNameLength As UInt16 = 0
        rtn = IR_API_Class.IR_GetIrDevCmdNameInBuffer(CUShort(cboIRCmdNo2.SelectedIndex + 1), IrDevNameArr, CUShort(IrDevNameArr.Length), IrDevNameLength,
                   IrCmdNameArr, CUShort(IrCmdNameArr.Length), IrCmdNameLength)

        txtIRDevNameGet.Text = Encoding.UTF8.GetString(IrDevNameArr, 0, IrDevNameLength)
        txtIRCmdNameGet.Text = Encoding.UTF8.GetString(IrCmdNameArr, 0, IrCmdNameLength)

    End Sub

    Private Sub btnSetIrDevCmdNameInBuffer_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = 0
        Dim IrDevNameArrTemp As Byte() = Encoding.UTF8.GetBytes(txtIRDevNameSet.Text)
        Dim IrCmdNameArrTemp As Byte() = Encoding.UTF8.GetBytes(txtIRCmdNameSet.Text)


        rtn = IR_API_Class.IR_SetIrDevCmdNameInBuffer(
                CUShort(cboIRCmdNo2.SelectedIndex + 1),
                IrDevNameArrTemp, CUShort(IrDevNameArrTemp.Length),
                IrCmdNameArrTemp, CUShort(IrCmdNameArrTemp.Length)
                )
    End Sub

    Private Sub btnRefreshIRDevCmdNameInLibBuf_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = 0
        Dim IrDevNameArr(99) As Byte
        Dim IrCmdNameArr(99) As Byte
        Dim IrDevNameLength As UInt16 = 0
        Dim IrCmdNameLength As UInt16 = 0
        Dim irCmdNo As UInt16 = 0

        btnGetIRCmdSummaryBuff_Click(sender, e)    ' Get IR cmd summary from the IR library buffer.

        cboDeviceName.Items.Clear()
        cboIrCmdNameArr.Items.Clear()

        ' Initialize the items of IR device names & IR cmd name (comments) comboboxes.  
        For i As Integer = 0 To (IrCmdSummaryArr(0) - 1)
            For j As Integer = 0 To (IrCmdSummaryArr(i + 2) - 1)
                irCmdNo = irCmdNo + 1
                rtn = IR_API_Class.IR_GetIrDevCmdNameInBuffer(irCmdNo, IrDevNameArr, CShort(IrDevNameArr.Length), IrDevNameLength,
                           IrCmdNameArr, CShort(IrCmdNameArr.Length), IrCmdNameLength)

                cboIrCmdNameArr.Items.Add(irCmdNo.ToString() + "_" + Encoding.UTF8.GetString(IrCmdNameArr, 0, IrCmdNameLength))
            Next j

            cboDeviceName.Items.Add((i + 1).ToString + "_" + Encoding.UTF8.GetString(IrDevNameArr, 0, IrDevNameLength))
        Next i

        If ((cboDeviceName.Items.Count <> 0) And (cboIrCmdNameArr.Items.Count <> 0)) Then
            cboDeviceName.SelectedIndex = 0
            cboIrCmdNameArr.SelectedIndex = 0
        End If
    End Sub

    Private Sub btnMUdpLrnON_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = IR_API_Class.IR_MUDP_LrnModeSet(socketHandle, 1)

        If (rtn <> IR_API_Class.IR_E_OK) Then
            MessageBox.Show("IR-Learn-ON failed", "Error")
        End If
    End Sub

    Private Sub btnMUdpLrnOFF_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = IR_API_Class.IR_MUDP_LrnModeSet(socketHandle, 0)

        If (rtn <> IR_API_Class.IR_E_OK) Then
            MessageBox.Show("IR-Learn-OFF failed", "Error")
        End If
    End Sub

    Private Sub btnIsLearnOK_Click(sender As Object, e As RoutedEventArgs)
        Dim isLearnOK As UInt16 = 0   ' Variable to indicate if learning an IR cmd Is completed. 0=>Not yet. 1=>completed.
        Dim rtn As Integer = IR_API_Class.IR_MUDP_IsIRLearnOK(socketHandle, isLearnOK, Int32.Parse(txtRecvTout.Text))
        txtIsLrnOKRtn.Text = rtn.ToString()
        MessageBox.Show("Is IR-Learning OK? => " + If(isLearnOK = 1, "OK", "Not OK"), "Is IR learning OK?")
    End Sub

    Private Sub btnGetIRCmdAfterLrn_Click(sender As Object, e As RoutedEventArgs)
        Dim cboCurrSelectedIndex As Integer = cboIrCmdNameArr.SelectedIndex
        Dim rtn As Integer = IR_API_Class.IR_MUDP_GetIRCmdAfterLearn(socketHandle, CUShort(cboCurrSelectedIndex + 1))

        If (rtn = IR_API_Class.IR_E_OK) Then
            cboIrCmdNameArr_DropDownClosed(sender, e)
            MessageBox.Show("Call IR_MUDP_GetIRCmdAfterLearn() OK.", "OK")
        Else
            MessageBox.Show("Error in calling IR_MUDP_GetIRCmdAfterLearn()", "Error")
        End If
    End Sub

    Private Sub btnRunCmd_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = IR_API_Class.IR_MUDP_RunCommand(socketHandle, CUShort(cboIrCmdNameArr.SelectedIndex + 1), IROutputChArr(cboIROutputCh.SelectedIndex))

        If (rtn <> IR_API_Class.IR_E_OK) Then
            MessageBox.Show("Error in calling IR_MUDP_GetIRCmdAfterLearn()", "Error")
        End If
    End Sub

    Private Sub btnClearOneIRDataInLib_Click(sender As Object, e As RoutedEventArgs)
        Dim moduleIndex As UInt16 = &H21    ' IR-712-MTCP
        Dim cboIndex As Integer = cboIrCmdNameArr.SelectedIndex
        Dim rtn As Integer = IR_API_Class.IR_ClearOneIRLrnDataInAPI(CShort(cboIndex + 1), moduleIndex)

        If (rtn <> IR_API_Class.IR_E_OK) Then
            MessageBox.Show("IR_ClearOneIRLrnDataInAPI() return error code = " + rtn.ToString(), "IR_ClearOneIRLrnDataInAPI Error")
        End If

        cboIrCmdNameArr_DropDownClosed(sender, e)
    End Sub

    Private Sub btnGetIRCmdSummary_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = 0
        Dim moduleIndex As UInt16 = &H21   ' 0x21: ModuleIndex of IR-712-MTCP
        Dim dataArr(12) As UInt16
        Dim dataArr2(12) As UInt16
        Dim dataArr3(12) As UInt16
        Dim dataStr As String = String.Empty

        rtn = IR_API_Class.IR_MUDP_GetIRCmdSummary(socketHandle, moduleIndex, dataArr, CShort(dataArr.Length))

        ' Show the IR command summary.
        For i As Integer = 0 To (dataArr.Length - 1)
            If (i = (dataArr.Length - 1)) Then
                dataStr += (dataArr(i).ToString())
                'dataStr += (dataArr(i).ToString("X4"))
            Else
                dataStr += (dataArr(i).ToString() + "-")
                'dataStr += (dataArr(i).ToString("X4") + "-")
            End If

            IrCmdSummaryArr(i) = dataArr(i)
        Next i

        txtGetIRCmdSummaryRtn.Text = rtn.ToString()
        txtGetIRCmdSummary.Text = dataStr

        IrDeviceTotalQty = dataArr(0)
        IrCmdCurrTotalCmd = dataArr(1)
    End Sub

    Private Sub btnSetIRCmdSummary_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = 0
        Dim moduleIndex As UInt16 = &H21    ' 0x21: ModuleIndex of IR-712-MTCP
        Dim dataArr(12) As UInt16

        Dim msgRst As MessageBoxResult = MessageBox.Show(
                "Before pressing this button, press the ""btnSetIRCmdSummaryBuff"" button in advance in group Step 4 to update the IR cmd summary if necessary. " _
                + vbCrLf + "This button will write the IR command summary in the library buffer " _
                + vbCrLf + "to the flash memory of the IR module." _
                + vbCrLf + "Are you sure to proceed?" _
                + vbCrLf,
                "Warning", MessageBoxButton.YesNo,
                MessageBoxImage.Warning)

        If (msgRst = MessageBoxResult.No) Then
            Return
        End If


        btnSetIRCmdSummaryBuff_Click(sender, e)

        rtn = IR_API_Class.IR_MUDP_SetIRCmdSummary(socketHandle, moduleIndex)

        'dataArr(0) = Byte.Parse(txtDeviceQty.Text)
        'dataArr(1) = Byte.Parse(txtIRCmdQtyTotal.Text)
        'dataArr(2) = Byte.Parse(txtIRCmdQtyDevice1.Text)
        'dataArr(3) = Byte.Parse(txtIRCmdQtyDevice2.Text)
        'dataArr(4) = Byte.Parse(txtIRCmdQtyDevice3.Text)
        'dataArr(5) = Byte.Parse(txtIRCmdQtyDevice4.Text)
        'dataArr(6) = Byte.Parse(txtIRCmdQtyDevice5.Text)
        'dataArr(7) = Byte.Parse(txtIRCmdQtyDevice6.Text)
        'dataArr(8) = Byte.Parse(txtIRCmdQtyDevice7.Text)
        'dataArr(9) = Byte.Parse(txtIRCmdQtyDevice8.Text)
        'dataArr(10) = Byte.Parse(txtIRCmdQtyDevice9.Text)
        'dataArr(11) = Byte.Parse(txtIRCmdQtyDevice10.Text)
        'dataArr(12) = Byte.Parse(txtIRCmdQtyDevice11.Text)

        'rtn = IR_API_Class.IR_MTCP_SetIRCmdSummary1(socketHandle, moduleIndex, dataArr, CShort(dataArr.Length))



        txtSetIRCmdSummaryRtn.Text = rtn.ToString()

        'MessageBox.Show("a[0]=" + dataArr(0).ToString("X2") _
        '                  + vbCrLf + "a[1]=" + dataArr(1).ToString("X2") _
        '                  + vbCrLf + "a[2]=" + dataArr(2).ToString("X2") _
        '                  + vbCrLf + "a[3]=" + dataArr(3).ToString("X2") _
        '                  + vbCrLf + "a[4]=" + dataArr(4).ToString("X2") _
        '                  + vbCrLf + "a[5]=" + dataArr(5).ToString("X2") _
        '                  + vbCrLf + "a[6]=" + dataArr(6).ToString("X2") _
        '                  + vbCrLf + "a[7]=" + dataArr(7).ToString("X2")
        '                  )
    End Sub

    Private Sub btnDLOneIRDataToModule_Click(sender As Object, e As RoutedEventArgs)
        thDwLDIR = New Thread(New ThreadStart(AddressOf DownloadIRProcess))
        thDwLDIR.Start()
    End Sub

    Private Sub DownloadIRProcess()
        Dim rtn As Integer = 0
        For ii = 0 To (IrCmdCurrTotalCmd - 1)
            rtn = IR_API_Class.IR_MUDP_DLOneIRDataToModule(socketHandle, CUShort(ii + 1))

            If (rtn <> IR_API_Class.IR_E_OK) Then
                MessageBox.Show("Failed to download IR cmds", "Download Error")
                Return
            End If

            Dispatcher.BeginInvoke(Sub() Update_txtIRCmdQtyCurr())

            Thread.Sleep(50)
        Next

        MessageBox.Show("Download " + IrCmdCurrTotalCmd.ToString() + " IR cmds to the IR modules successfully.", "Download OK")
    End Sub

    Private Sub Update_txtIRCmdQtyCurr()
        txtIRCmdQtyCurr.Text = (ii + 1).ToString()
    End Sub

    Private Sub btnLDOneIRDataToAPI_Click(sender As Object, e As RoutedEventArgs)
        thLDIR = New Thread(New ThreadStart(AddressOf LoadIRProcess))
        thLDIR.Start()
    End Sub

    Private Sub LoadIRProcess()

        Dim rtn As Integer = 0
        'Dim i As Integer = 0
        For ii = 0 To (IrCmdCurrTotalCmd - 1)
            rtn = IR_API_Class.IR_MUDP_LDOneIRDataToAPI(socketHandle, CUShort(ii + 1))

            If (rtn <> IR_API_Class.IR_E_OK) Then
                MessageBox.Show("Failed to load IR cmds", "load Error")
                Return
            End If

            Dispatcher.BeginInvoke(Sub() Update_txtIRCmdQtyCurr())
            Thread.Sleep(50)
        Next

        MessageBox.Show("Load " + IrCmdCurrTotalCmd.ToString() + " IR cmds back to the IR API library successfully.", "Load back OK")

    End Sub

    Private Sub btnEmitIRCmd_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = IR_API_Class.IR_MUDP_EmitIrSignal(socketHandle, CUShort(cboIRCmdNo.SelectedIndex + 1), IROutputChArr(cboIROutputCh2.SelectedIndex))
    End Sub

    Private Sub btnSaveIRCmdToFile_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = IR_API_Class.IR_SaveIRCmdsToFile(txtFilePath_Save.Text)
        txtSaveIRCmdToFileRtn.Text = rtn.ToString()

        If (rtn <> IR_API_Class.IR_E_OK) Then
            MessageBox.Show("Save failed.")
        End If
    End Sub

    Private Sub btnLoadIRCmdToFile_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = IR_API_Class.IR_LoadIRCmdsFromFile(txtFilePath_Load.Text)
        txtLoadIRCmdToFileRtn.Text = rtn.ToString()

        If (rtn <> IR_API_Class.IR_E_OK) Then
            MessageBox.Show("Load failed.")
        End If
    End Sub

    Private Sub btnGetMBRecvTOut_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = IR_API_Class.IR_MUDP_GetModbusRecvTimeout()
        txtRecvTout1.Text = rtn.ToString()
    End Sub

    Private Sub btnSetMBRecvTOut_Click(sender As Object, e As RoutedEventArgs)
        IR_API_Class.IR_MUDP_SetModbusRecvTimeout(UInt16.Parse(txtRecvTout1.Text))
    End Sub

    Private Sub txtIRCmdQtyDevice1_TextChanged(sender As Object, e As TextChangedEventArgs)
        Dim irCmdOtyTotal As Integer = 0
        Dim irCmdQtyDevice As Integer = 0
        Dim irDeviceQtyTotal As Integer = 0

        ' #1 device - IR cmd qty
        If (txtIRCmdQtyDevice1 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice1.Text, irCmdQtyDevice) = False) Then
            'If (txtIRCmdQtyDevice1 Is Nothing) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        'irDeviceQtyTotal += (irCmdQtyDevice > 0 ? 1 : 0)
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'conditional ternary operator

        ' #2 device - IR cmd qty
        If (txtIRCmdQtyDevice2 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice2.Text, irCmdQtyDevice) = False) Then
            'If (txtIRCmdQtyDevice2 Is Nothing) Or (Int16.TryParse(txtIRCmdQtyDevice2.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        ' #3 device - IR cmd qty
        If (txtIRCmdQtyDevice3 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice3.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        ' #4 device - IR cmd qty
        If (txtIRCmdQtyDevice4 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice4.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        ' #5 device - IR cmd qty
        If (txtIRCmdQtyDevice5 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice5.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        ' #6 device - IR cmd qty
        If (txtIRCmdQtyDevice6 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice6.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        ' #7 device - IR cmd qty
        If (txtIRCmdQtyDevice7 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice7.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        ' #8 device - IR cmd qty
        If (txtIRCmdQtyDevice8 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice8.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        ' #9 device - IR cmd qty
        If (txtIRCmdQtyDevice9 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice9.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        ' #10 device - IR cmd qty
        If (txtIRCmdQtyDevice10 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice10.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        ' #11 device - IR cmd qty
        If (txtIRCmdQtyDevice11 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice11.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        txtIRCmdQtyTotal.Text = irCmdOtyTotal.ToString()
        txtDeviceQty.Text = irDeviceQtyTotal.ToString()
    End Sub

    Private Sub cboIrCmdNameArr_DropDownClosed(sender As Object, e As EventArgs)
        Dim rtn As Integer = 0
        rtn = IR_API_Class.IR_ChkIrDataExistInBuffer(CType(cboIrCmdNameArr.SelectedIndex + 1, UInt16))


        If (rtn = IR_API_Class.IR_E_IRCMD_DATA_EXIST) Then
            Rect1.Fill = New SolidColorBrush(System.Windows.Media.Colors.Red)
        Else
            Rect1.Fill = New SolidColorBrush(System.Windows.Media.Colors.White)
        End If
    End Sub

    Private Sub cboIrCmdNameArr_SelectionChanged(sender As Object, e As SelectionChangedEventArgs)
        Dim rtn As Integer = 0
        rtn = IR_API_Class.IR_ChkIrDataExistInBuffer(CType(cboIrCmdNameArr.SelectedIndex + 1, UInt16))


        If (rtn = IR_API_Class.IR_E_IRCMD_DATA_EXIST) Then
            Rect1.Fill = New SolidColorBrush(System.Windows.Media.Colors.Red)
        Else
            Rect1.Fill = New SolidColorBrush(System.Windows.Media.Colors.White)
        End If
    End Sub

    Private Sub cboDeviceName_DropDownClosed(sender As Object, e As EventArgs)
        Dim cbo As ComboBox = sender
        Dim index As Integer = 0
        For i As Integer = 0 To (cbo.SelectedIndex - 1)
            index += IrCmdSummaryArr(i + 2)
        Next
        cboIrCmdNameArr.SelectedIndex = index   ' Show the first IR cmd name For the IR device #.
    End Sub
End Class
